blob: d64b687dd91f7306a1526efa035d65542bec6675 [file] [log] [blame]
Peter Stuge09377b72011-08-21 06:24:55 +02001#!/bin/sh
Stefan Reinauer074d9132009-09-26 16:43:17 +00002#
Stefan Reinauer5f1ad892010-05-17 11:02:25 +00003# Copyright (C) 2008-2010 by coresystems GmbH
Stefan Reinauer074d9132009-09-26 16:43:17 +00004# written by Patrick Georgi <patrick.georgi@coresystems.de> and
5# Stefan Reinauer <stefan.reinauer@coresystems.de>
Stefan Reinauer14e22772010-04-27 06:56:47 +00006#
Marc Jones2aac3f62011-08-08 16:07:50 -06007# Copyright (C) 2011 by Sage Electronic Engineering
8#
Stefan Reinauer074d9132009-09-26 16:43:17 +00009# This program is free software; you can redistribute it and/or modify
10# it under the terms of the GNU General Public License as published by
11# the Free Software Foundation; version 2 of the License.
12#
13# This program is distributed in the hope that it will be useful,
14# but WITHOUT ANY WARRANTY; without even the implied warranty of
15# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
16# GNU General Public License for more details.
17#
Stefan Reinauer074d9132009-09-26 16:43:17 +000018
Stefan Reinauerd7649122015-06-09 11:44:25 -070019cd $(dirname $0)
Patrick Georgi8135dba2015-03-17 21:05:20 +010020
Martin Roth2ab981b2016-08-31 16:43:49 -060021CROSSGCC_DATE="August 31st, 2016"
22CROSSGCC_VERSION="1.43"
Stefan Reinauer88352d72016-04-06 15:57:03 -070023CROSSGCC_COMMIT=$( git describe )
Stefan Reinauer074d9132009-09-26 16:43:17 +000024
25# default settings
Stefan Reinauer85b07d62015-06-09 14:45:14 -070026PACKAGE=GCC
Stefan Reinauerd7649122015-06-09 11:44:25 -070027TARGETDIR=$(pwd)/xgcc
Stefan Reinauer074d9132009-09-26 16:43:17 +000028TARGETARCH=i386-elf
Nico Huber66c2c1a2016-09-20 13:09:29 +020029DEFAULT_LANGUAGES=c
30LANGUAGES=
Stefan Reinauer074d9132009-09-26 16:43:17 +000031DESTDIR=
Stefan Reinauer85b07d62015-06-09 14:45:14 -070032SAVETEMPS=0
33SKIPPYTHON=1
Nico Huber234d2462016-01-26 16:10:17 +010034BOOTSTRAP=0
Martin Roth2c6a8062016-11-14 11:58:39 -070035THREADS=1
Stefan Reinauer074d9132009-09-26 16:43:17 +000036
Stefan Reinauer699ac272015-06-05 12:43:28 -070037# GCC toolchain version numbers
Timothy Pearson96310162015-12-28 22:53:29 -060038GMP_VERSION=6.1.0
Iru Caiae8e3a02016-04-02 10:50:59 +080039MPFR_VERSION=3.1.4
Paul Menzele6619422015-02-23 10:33:59 +010040MPC_VERSION=1.0.3
Stefan Reinauer5f1ad892010-05-17 11:02:25 +000041LIBELF_VERSION=0.8.13
Iru Caiae8e3a02016-04-02 10:50:59 +080042GCC_VERSION=5.3.0
Stefan Reinauer0d2119d2013-07-10 14:27:56 -070043GCC_AUTOCONF_VERSION=2.69
Martin Rothbcfa7cc2016-07-14 13:01:37 -060044BINUTILS_VERSION=2.26.1
Stefan Reinauer498f3d02016-04-21 18:10:15 -070045GDB_VERSION=7.11
Martin Roth2ab981b2016-08-31 16:43:49 -060046IASL_VERSION=20160831
Stefan Reinauer3dc5d072016-04-21 19:29:03 -070047PYTHON_VERSION=3.5.1
Stefan Reinauer498f3d02016-04-21 18:10:15 -070048EXPAT_VERSION=2.1.1
Stefan Reinauer14ce2132015-06-05 13:01:13 -070049# CLANG version number
Iru Caiae8e3a02016-04-02 10:50:59 +080050CLANG_VERSION=3.8.0
Martin Roth589ef9d2016-08-11 18:35:06 -060051MAKE_VERSION=4.2.1
Stefan Reinauer074d9132009-09-26 16:43:17 +000052
Stefan Reinauer699ac272015-06-05 12:43:28 -070053# GCC toolchain archive locations
Martin Roth1484c032016-03-08 09:37:14 -070054# These are sanitized by the jenkins toolchain test builder, so if
55# a completely new URL is added here, it probably needs to be added
56# to the jenkins build as well, or the builder won't download it.
Stefan Reinauerd9d21022016-04-21 18:16:30 -070057GMP_ARCHIVE="http://ftpmirror.gnu.org/gmp/gmp-${GMP_VERSION}.tar.xz"
58MPFR_ARCHIVE="http://ftpmirror.gnu.org/mpfr/mpfr-${MPFR_VERSION}.tar.xz"
Idwer Vollering7962fc72012-10-25 02:14:09 +020059MPC_ARCHIVE="http://ftpmirror.gnu.org/mpc/mpc-${MPC_VERSION}.tar.gz"
Stefan Reinauer5f1ad892010-05-17 11:02:25 +000060LIBELF_ARCHIVE="http://www.mr511.de/software/libelf-${LIBELF_VERSION}.tar.gz"
Idwer Vollering1cfee0b2012-10-25 02:03:53 +020061GCC_ARCHIVE="http://ftpmirror.gnu.org/gcc/gcc-${GCC_VERSION}/gcc-${GCC_VERSION}.tar.bz2"
Stefan Reinauer0d2119d2013-07-10 14:27:56 -070062BINUTILS_ARCHIVE="http://ftpmirror.gnu.org/binutils/binutils-${BINUTILS_VERSION}.tar.bz2"
Patrick Georgi53c388f2015-03-07 09:55:18 +010063GDB_ARCHIVE="http://ftpmirror.gnu.org/gdb/gdb-${GDB_VERSION}.tar.xz"
Patrick Georgi85bb9462016-02-11 17:22:16 +010064IASL_ARCHIVE="https://acpica.org/sites/acpica/files/acpica-unix2-${IASL_VERSION}.tar.gz"
Patrick Georgi53c388f2015-03-07 09:55:18 +010065PYTHON_ARCHIVE="http://www.python.org/ftp/python/${PYTHON_VERSION}/Python-${PYTHON_VERSION}.tar.xz"
Stefan Reinauer498f3d02016-04-21 18:10:15 -070066EXPAT_ARCHIVE="http://downloads.sourceforge.net/sourceforge/expat/expat-${EXPAT_VERSION}.tar.bz2"
Stefan Reinauer14ce2132015-06-05 13:01:13 -070067# CLANG toolchain archive locations
68LLVM_ARCHIVE="http://llvm.org/releases/${CLANG_VERSION}/llvm-${CLANG_VERSION}.src.tar.xz"
69CFE_ARCHIVE="http://llvm.org/releases/${CLANG_VERSION}/cfe-${CLANG_VERSION}.src.tar.xz"
70CRT_ARCHIVE="http://llvm.org/releases/${CLANG_VERSION}/compiler-rt-${CLANG_VERSION}.src.tar.xz"
71CTE_ARCHIVE="http://llvm.org/releases/${CLANG_VERSION}/clang-tools-extra-${CLANG_VERSION}.src.tar.xz"
Stefan Reinauera851bbb2016-01-29 18:03:26 -080072MAKE_ARCHIVE="http://ftpmirror.gnu.org/make/make-${MAKE_VERSION}.tar.bz2"
Stefan Reinauer074d9132009-09-26 16:43:17 +000073
Martin Roth58c68d52016-03-01 15:22:42 -070074ALL_ARCHIVES="$GMP_ARCHIVE $MPFR_ARCHIVE $MPC_ARCHIVE $LIBELF_ARCHIVE \
75 $GCC_ARCHIVE $BINUTILS_ARCHIVE $GDB_ARCHIVE $IASL_ARCHIVE \
76 $PYTHON_ARCHIVE $EXPAT_ARCHIVE $LLVM_ARCHIVE $CFE_ARCHIVE \
77 $CRT_ARCHIVE $CTE_ARCHIVE $MAKE_ARCHIVE"
78
Stefan Reinauer699ac272015-06-05 12:43:28 -070079# GCC toolchain directories
Stefan Reinauer074d9132009-09-26 16:43:17 +000080GMP_DIR="gmp-${GMP_VERSION}"
81MPFR_DIR="mpfr-${MPFR_VERSION}"
Stefan Reinauer5f1ad892010-05-17 11:02:25 +000082MPC_DIR="mpc-${MPC_VERSION}"
83LIBELF_DIR="libelf-${LIBELF_VERSION}"
Stefan Reinauer074d9132009-09-26 16:43:17 +000084GCC_DIR="gcc-${GCC_VERSION}"
85BINUTILS_DIR="binutils-${BINUTILS_VERSION}"
86GDB_DIR="gdb-${GDB_VERSION}"
Patrick Georgi85bb9462016-02-11 17:22:16 +010087IASL_DIR="acpica-unix2-${IASL_VERSION}"
Stefan Reinauer2c3cd122011-11-01 21:43:50 +010088PYTHON_DIR="Python-${PYTHON_VERSION}"
89EXPAT_DIR="expat-${EXPAT_VERSION}"
Stefan Reinauer14ce2132015-06-05 13:01:13 -070090# CLANG toolchain directories
91LLVM_DIR="llvm-${CLANG_VERSION}.src"
92CFE_DIR="cfe-${CLANG_VERSION}.src"
93CRT_DIR="compiler-rt-${CLANG_VERSION}.src"
94CTE_DIR="clang-tools-extra-${CLANG_VERSION}.src"
Stefan Reinauera851bbb2016-01-29 18:03:26 -080095MAKE_DIR="make-${MAKE_VERSION}"
Stefan Reinauer074d9132009-09-26 16:43:17 +000096
Patrick Georgi6321f522015-02-27 23:36:26 +010097unset MAKELEVEL MAKEFLAGS
98
Patrick Georgi1861ff72011-10-31 12:15:55 +010099red='\033[0;31m'
100RED='\033[1;31m'
101green='\033[0;32m'
102GREEN='\033[1;32m'
103blue='\033[0;34m'
104BLUE='\033[1;34m'
105cyan='\033[0;36m'
106CYAN='\033[1;36m'
107NC='\033[0m' # No Color
Stefan Reinauer074d9132009-09-26 16:43:17 +0000108
zbaoe05c1ea2015-08-05 23:10:05 -0400109UNAME=$(uname | grep -iq cygwin && echo Cygwin || uname)
Martin Roth88463822016-01-07 11:03:36 -0700110HALT_FOR_TOOLS=0
Stefan Reinauer0d2119d2013-07-10 14:27:56 -0700111
Patrick Georgi198d23c2012-12-08 08:02:44 +0100112normalize_dirs()
113{
114 mkdir -p $DESTDIR$TARGETDIR/lib
115 test -d $DESTDIR$TARGETDIR/lib32 && mv $DESTDIR$TARGETDIR/lib32/* $DESTDIR$TARGETDIR/lib
116 test -d $DESTDIR$TARGETDIR/lib64 && mv $DESTDIR$TARGETDIR/lib64/* $DESTDIR$TARGETDIR/lib
117 rmdir -p $DESTDIR$TARGETDIR/lib32 $DESTDIR$TARGETDIR/lib64
118
119 perl -pi -e "s,/lib32,/lib," $DESTDIR$TARGETDIR/lib/*.la
120 perl -pi -e "s,/lib64,/lib," $DESTDIR$TARGETDIR/lib/*.la
121}
122
Stefan Reinauer93a96302015-06-15 12:36:53 -0700123please_install()
124{
Martin Roth88463822016-01-07 11:03:36 -0700125 HALT_FOR_TOOLS=1
Patrick Georgi5da95dc2015-07-17 23:33:05 +0200126 test -r /etc/os-release && . /etc/os-release
Stefan Reinauer93a96302015-06-15 12:36:53 -0700127 case "$ID_LIKE" in
128 debian) solution="sudo apt-get install $1" ;;
129 suse) solution="sudo zypper install $1" ;;
130 *) solution="using your OS packaging system" ;;
131 esac
132
Martin Roth591790f2016-03-20 20:39:04 -0600133 printf "${RED}ERROR:${red} Missing tool: Please install \'$1\'. (eg $solution)${NC}\n" >&2
Martin Rothe3963172016-01-06 13:54:32 -0700134 if [ -n "$2" ]; then
Martin Roth591790f2016-03-20 20:39:04 -0600135 printf "${RED}ERROR:${red} or install \'$2\'.${NC}\n" >&2
Martin Rothe3963172016-01-06 13:54:32 -0700136 fi
Stefan Reinauer93a96302015-06-15 12:36:53 -0700137}
138
Patrick Georgib7062882015-02-24 10:52:14 +0100139searchtool()
Stefan Reinauer074d9132009-09-26 16:43:17 +0000140{
141 # $1 short name
Patrick Georgib7062882015-02-24 10:52:14 +0100142 # $2 search string
143 # $3 soft fail if set
Martin Rothe3963172016-01-06 13:54:32 -0700144 # $4 alternative package to install on failure
Patrick Georgib7062882015-02-24 10:52:14 +0100145 # result: file name of that tool on stdout
146 # or no output if nothing suitable was found
147 search=GNU
148 if [ -n "$2" ]; then
149 search="$2"
150 fi
Stefan Reinauer074d9132009-09-26 16:43:17 +0000151 for i in "$1" "g$1" "gnu$1"; do
Stefan Reinauerdbc00872015-06-09 11:50:05 -0700152 if [ -x "$(which $i 2>/dev/null)" ]; then
153 if [ "$(cat /dev/null | $i --version 2>&1 | grep -c "$search")" \
154 -gt 0 ]; then
Stefan Reinauer074d9132009-09-26 16:43:17 +0000155 echo $i
156 return
157 fi
158 fi
159 done
Andrew Wub67e9a12014-04-28 18:13:44 +0800160 # A workaround for OSX 10.9 and some BSDs, whose nongnu
161 # patch and tar also work.
Patrick Georgi7cb26b42015-04-28 21:29:22 +0200162 if [ $UNAME = "Darwin" -o $UNAME = "FreeBSD" -o $UNAME = "NetBSD" -o $UNAME = "OpenBSD" ]; then
Patrick Georgib7062882015-02-24 10:52:14 +0100163 if [ "$1" = "patch" -o "$1" = "tar" ]; then
Stefan Reinauerdbc00872015-06-09 11:50:05 -0700164 if [ -x "$(which $1 2>/dev/null)" ]; then
Zheng Bao36156ff2012-09-28 16:18:58 +0800165 echo $1
166 return
167 fi
168 fi
169 fi
zbao5cf758d2015-09-01 22:28:57 -0400170 if echo $1 | grep -q "sum" ; then
171 algor=$(echo $1 | sed -e 's,sum,,')
172 if [ -x "$(which $1 2>/dev/null)" ]; then
173 #xxxsum [file]
174 echo $1
175 return
176 elif [ -x "$(which $algor 2>/dev/null)" ]; then
177 #xxx [file]
178 echo $algor
179 return
180 elif [ -x "$(which openssl 2>/dev/null)" ]; then
181 #openssl xxx [file]
182 echo openssl $algor
183 return
184 elif [ -x "$(which cksum 2>/dev/null)" ]; then
185 #cksum -a xxx [file]
186 #cksum has special options in NetBSD. Actually, NetBSD will use the second case above.
187 echo "buildgcc" | cksum -a $algor > /dev/null 2>/dev/null && \
188 echo cksum -a $algor
189 return
zbao939dc842015-04-30 04:44:07 +0800190 fi
191 fi
Martin Rothe3963172016-01-06 13:54:32 -0700192
Martin Roth88463822016-01-07 11:03:36 -0700193 [ -z "$3" ] && please_install $1 $4
Patrick Georgib7062882015-02-24 10:52:14 +0100194 false
Stefan Reinauer074d9132009-09-26 16:43:17 +0000195}
196
Martin Roth591790f2016-03-20 20:39:04 -0600197# Run a compile check of the specified library option to see if it's installed
198check_for_library() {
199 local LIBRARY_FLAGS=$1
Aaron Durbin0ac4e5a2016-04-07 16:56:25 -0500200 local LIBRARY_PACKAGES="$2"
Martin Roth591790f2016-03-20 20:39:04 -0600201 local LIBTEST_FILE=.libtest
202
203 echo "int main(int argc, char **argv) { (void) argc; (void) argv; return 0; }" > "${LIBTEST_FILE}.c"
204
205 cc $CFLAGS $LIBRARY_FLAGS "${LIBTEST_FILE}.c" -o "${LIBTEST_FILE}" >/dev/null 2>&1 || \
206 please_install "$LIBRARY_PACKAGES"
207 rm -rf "${LIBTEST_FILE}.c" "${LIBTEST_FILE}"
208}
209
Nico Huberaee7f462016-09-20 12:55:19 +0200210buildcc_major() {
211 echo "${GCC_VERSION}" | cut -d. -f1
212}
213
214buildcc_version() {
215 echo "${GCC_VERSION}" | cut -d. -f1-2
216}
217
218hostcc_major() {
219 (echo __GNUC__ | ${CC} -E - 2>/dev/null || echo 0) | tail -1
220}
221
222hostcc_minor() {
223 (echo __GNUC_MINOR__ | ${CC} -E - 2>/dev/null || echo 0) | tail -1
224}
225
226hostcc_version() {
227 printf "%d.%d" "$(hostcc_major)" "$(hostcc_minor)"
228}
229
Nico Huber75797162016-09-20 13:01:57 +0200230hostcc_has_gnat1() {
231 [ -x "$(${CC} -print-prog-name=gnat1)" ]
232}
233
234ada_requested() {
235 echo "${LANGUAGES}" | grep -q '\<ada\>'
236}
237
238check_gnat() {
239 if hostcc_has_gnat1; then
240 if [ "$(hostcc_version)" != "$(buildcc_version)" -a "${BOOTSTRAP}" != "1" ]; then
241 printf "\n${RED}ERROR:${red} Building the Ada compiler (gnat $(buildcc_version)) "
242 printf "with a different host compiler\n version ($(hostcc_version)) "
243 printf "requires bootstrapping (-b).${NC}\n\n"
244 HALT_FOR_TOOLS=1
245 fi
Nico Huber04a1f6a2016-09-20 13:07:49 +0200246 else
247 please_install gnat
Nico Huber75797162016-09-20 13:01:57 +0200248 fi
249}
250
Nico Huber156d87c2016-09-20 12:59:53 +0200251check_cc() {
252 if is_package_enabled "GCC"; then
253 if [ "$(hostcc_major)" != "$(buildcc_major)" -a "${BOOTSTRAP}" != "1" ]; then
254 printf "\n${red}warning: Building GCC $(buildcc_version) with a different major "
255 printf "version ($(hostcc_version)).\n"
256 printf " Bootstrapping (-b) is recommended.${NC}\n\n"
257 fi
Nico Huber75797162016-09-20 13:01:57 +0200258 if ada_requested; then
259 check_gnat
260 fi
Nico Huber156d87c2016-09-20 12:59:53 +0200261 fi
262}
263
zbao06e85ac2015-08-24 22:08:36 -0400264check_sum() {
265 test -z "$CHECKSUM" || \
266 test "$(cat sum/$1.cksum 2>/dev/null | sed -e 's@.*\([0-9a-f]\{40,\}\).*@\1@')" = \
267 "$($CHECKSUM tarballs/$1 2>/dev/null | sed -e 's@.*\([0-9a-f]\{40,\}\).*@\1@')"
268}
269
270compute_sum() {
271 test ! -f sum/$1.cksum && test -f tarballs/$1 && \
272 (test -z "$CHECKSUM" || $CHECKSUM tarballs/$1 > sum/$1.cksum ) && \
273 printf "(checksum created. ${RED}Note. Please upload sum/$1.cksum if the corresponding archive is upgraded.)${NC}"
274}
275
zbao282dd952015-09-06 05:00:04 -0400276download_showing_percentage() {
277 url=$1
278 printf " ..${red} 0%%"
279 wget --no-check-certificate $url 2>&1 | while read line; do
zbao282dd952015-09-06 05:00:04 -0400280 echo $line | grep -o "[0-9]\+%" | awk '{printf("\b\b\b\b%4s", $1)}'
zbao282dd952015-09-06 05:00:04 -0400281 done
Zheng Baobb003c82016-08-05 13:41:51 +0800282 printf "${NC}"
zbao282dd952015-09-06 05:00:04 -0400283}
284
Stefan Reinauer88935482015-06-05 09:51:10 -0700285download() {
Stefan Reinauere7757bd2015-06-05 13:59:44 -0700286 package=$1
287 archive="$(eval echo \$$package"_ARCHIVE")"
Stefan Reinauer699ac272015-06-05 12:43:28 -0700288
Stefan Reinauerd7649122015-06-09 11:44:25 -0700289 FILE=$(basename $archive)
Stefan Reinauer88935482015-06-05 09:51:10 -0700290 printf " * $FILE "
291
zbaod22b9ea2015-08-30 23:35:16 -0400292 if test -f tarballs/$FILE && check_sum $FILE ; then
293 printf "(cached)"
294 else
Paul Menzelb2ba3952015-06-12 11:58:14 +0200295 printf "(downloading from $archive)"
Stefan Reinauer88935482015-06-05 09:51:10 -0700296 rm -f tarballs/$FILE
297 cd tarballs
zbao282dd952015-09-06 05:00:04 -0400298 download_showing_percentage $archive
Stefan Reinauer88935482015-06-05 09:51:10 -0700299 cd ..
zbao06e85ac2015-08-24 22:08:36 -0400300 compute_sum $FILE
zbaod22b9ea2015-08-30 23:35:16 -0400301 fi
302
Stefan Reinauerdbc00872015-06-09 11:50:05 -0700303 if [ ! -f tarballs/$FILE ]; then
zbao282dd952015-09-06 05:00:04 -0400304 printf "\n${RED}Failed to download $FILE.${NC}\n"
Stefan Reinauerdbc00872015-06-09 11:50:05 -0700305 exit 1
306 fi
Stefan Reinauer88935482015-06-05 09:51:10 -0700307 printf "\n"
308}
309
310unpack_and_patch() {
Stefan Reinauere7757bd2015-06-05 13:59:44 -0700311 package=$1
312 archive="$(eval echo \$$package"_ARCHIVE")"
313 dir="$(eval echo \$$package"_DIR")"
Stefan Reinauer88935482015-06-05 09:51:10 -0700314 test -d ${dir} && test -f ${dir}/.unpack_success || (
Stefan Reinauerd7649122015-06-09 11:44:25 -0700315 printf " * $(basename $archive)\n"
Stefan Reinauer88935482015-06-05 09:51:10 -0700316 FLAGS=zxf
Stefan Reinauerd7649122015-06-09 11:44:25 -0700317 suffix=$(echo $archive | sed 's,.*\.,,')
Martin Roth95f7b222016-03-20 12:38:48 -0600318 if [ "$suffix" = "gz" ] && [ -n "$PIGZ" ]; then FLAGS="-I pigz -xf"
319 elif [ "$suffix" = "gz" ]; then FLAGS=zxf
320 elif [ "$suffix" = "bz2" ] && [ -n "$LBZIP2" ]; then FLAGS="-I lbzip2 -xf"
321 elif [ "$suffix" = "bz2" ]; then FLAGS=jxf
322 elif [ "$suffix" = "xz" ]; then FLAGS="--xz -xf"
323 elif [ "$suffix" = "lzma" ]; then FLAGS="--lzma -xf"
324 fi
Stefan Reinauerd7649122015-06-09 11:44:25 -0700325 $TAR $FLAGS tarballs/$(basename $archive)
Stefan Reinauer88935482015-06-05 09:51:10 -0700326 for patch in patches/${dir}_*.patch; do
327 test -r $patch || continue
Stefan Reinauerd7649122015-06-09 11:44:25 -0700328 printf " o $(basename $patch)\n"
Nico Huber4b48ed82016-07-27 00:28:03 +0200329 (cd ${dir} && $PATCH -s -N -p1 <../${patch}) || {
Stefan Reinauer88935482015-06-05 09:51:10 -0700330 printf "\n${RED}Failed $patch.${NC}\n"
Stefan Reinauer916b8452015-06-09 11:54:49 -0700331 exit 1
332 }
Stefan Reinauer88935482015-06-05 09:51:10 -0700333 done
334 touch ${dir}/.unpack_success
335 )
336}
337
Stefan Reinauer1c70e052015-06-09 11:47:28 -0700338fn_exists()
339{
Patrick Georgic8665912015-06-11 21:04:31 +0200340 type $1 >/dev/null 2>&1
Patrick Georgi74c06422015-03-25 18:40:13 +0100341}
342
Patrick Georgif2c15f52015-06-11 21:07:31 +0200343is_package_enabled()
344{
345 echo "$PACKAGES" |grep -q "\<$1\>"
346}
347
Martin Roth444ece22016-04-01 18:46:29 -0600348package_uses_targetarch()
349{
Stefan Reinauera344b682016-04-21 19:29:51 -0700350 if [ "$1" = "GCC" ] || [ "$1" = "GDB" ] || [ "$1" = "BINUTILS" ]; then
Martin Roth444ece22016-04-01 18:46:29 -0600351 true
352 else
353 false
354 fi
355}
356
Nico Huber11ea2b32016-01-26 16:09:31 +0100357generic_build()
358{
Stefan Reinauere7757bd2015-06-05 13:59:44 -0700359 package=$1
Nico Huber11ea2b32016-01-26 16:09:31 +0100360 host_target=$2
361 builddir=$3
362 success=$4
Martin Rothc295d5e2016-11-14 11:56:11 -0700363 version=$5
Stefan Reinauer1c70e052015-06-09 11:47:28 -0700364
365 fn_exists build_$package || return
366
Nico Huber11ea2b32016-01-26 16:09:31 +0100367 mkdir -p "$builddir"
Stefan Reinauer1c70e052015-06-09 11:47:28 -0700368
Nico Huber11ea2b32016-01-26 16:09:31 +0100369 if [ -f "$success" ]; then
Martin Roth2c6a8062016-11-14 11:58:39 -0700370 printf "Skipping $package v$version for $host_target as it is already built\n"
Stefan Reinauere7757bd2015-06-05 13:59:44 -0700371 else
Martin Roth2c6a8062016-11-14 11:58:39 -0700372 printf "Building $package v$version for $host_target ... "
Nico Huber11ea2b32016-01-26 16:09:31 +0100373 DIR="$PWD"
374 cd "$builddir"
Stefan Reinauer1c70e052015-06-09 11:47:28 -0700375 rm -f .failed
Nico Huber11ea2b32016-01-26 16:09:31 +0100376 build_${package} $host_target > build.log 2>&1
377 cd "$DIR"
378 if [ ! -f "$builddir/.failed" ]; then
379 touch "$success";
380 else
381 printf "${RED}failed${NC}. Check $builddir/build.log.\n"
Stefan Reinauer1c70e052015-06-09 11:47:28 -0700382 exit 1
383 fi
384 printf "${green}ok${NC}\n"
Stefan Reinauere7757bd2015-06-05 13:59:44 -0700385 fi
386}
387
Nico Huber11ea2b32016-01-26 16:09:31 +0100388build_for_host()
389{
Martin Rothc295d5e2016-11-14 11:56:11 -0700390 package="$1"
391 version="$(eval echo \$$package"_VERSION")"
Patrick Georgi1b593e52016-11-25 15:27:41 +0100392 generic_build "$package" host "build-$package" "${DESTDIR}${TARGETDIR}/.${package}.${version}.success" "$version"
Nico Huber11ea2b32016-01-26 16:09:31 +0100393}
394
395build_for_target()
396{
Martin Rothc295d5e2016-11-14 11:56:11 -0700397 package="$1"
398 version="$(eval echo \$$package"_VERSION")"
Patrick Georgi1b593e52016-11-25 15:27:41 +0100399 generic_build "$package" target "build-${TARGETARCH}-$package" "${DESTDIR}${TARGETDIR}/.${TARGETARCH}-${package}.${version}.success" "$version"
Nico Huber11ea2b32016-01-26 16:09:31 +0100400}
401
402build()
403{
404 if package_uses_targetarch $1; then
Patrick Georgi1b593e52016-11-25 15:27:41 +0100405 if [ $BOOTSTRAP -eq 1 -a ! -f "${DESTDIR}${TARGETDIR}/.GCC.success" ]; then
Nico Huber234d2462016-01-26 16:10:17 +0100406 build_for_host GCC
407 fi
Nico Huber11ea2b32016-01-26 16:09:31 +0100408 build_for_target $1
409 else
410 build_for_host $1
411 fi
412}
413
Zheng Baobb003c82016-08-05 13:41:51 +0800414quit()
415{
416 printf "${NC}Stop\n"
417 exit 1
418}
419
Stefan Reinauer074d9132009-09-26 16:43:17 +0000420cleanup()
421{
Stefan Reinauer88e83e52016-04-06 15:39:48 -0700422 if [ $SAVETEMPS -ne 0 ]; then
423 printf "Leaving temporary files around... ${green}ok${NC}\n"
424 return
425 fi
426
Stefan Reinauer074d9132009-09-26 16:43:17 +0000427 printf "Cleaning up temporary files... "
Stefan Reinauere7757bd2015-06-05 13:59:44 -0700428 for package in $PACKAGES; do
Martin Roth444ece22016-04-01 18:46:29 -0600429 rm -rf build-${TARGETARCH}-$package build-$package $(eval echo \$$package"_DIR")
Stefan Reinauere7757bd2015-06-05 13:59:44 -0700430 done
zbaoff3f15c2015-08-26 22:00:31 -0400431 rm -f getopt
Stefan Reinauer074d9132009-09-26 16:43:17 +0000432 printf "${green}ok${NC}\n"
433}
434
435myhelp()
436{
Stefan Reinauer14ce2132015-06-05 13:01:13 -0700437 printf "Usage: $0 [-V] [-c] [-p <platform>] [-d <target directory>] [-D <dest dir>] [-C] [-G] [-S]\n"
Stefan Reinauer074d9132009-09-26 16:43:17 +0000438 printf " $0 [-V|--version]\n"
439 printf " $0 [-h|--help]\n\n"
440
441 printf "Options:\n"
442 printf " [-V|--version] print version number and exit\n"
443 printf " [-h|--help] print this help and exit\n"
444 printf " [-c|--clean] remove temporary files before build\n"
445 printf " [-t|--savetemps] don't remove temporary files after build\n"
Patrick Georgic1a75b12011-11-04 21:37:14 +0100446 printf " [-y|--ccache] Use ccache when building cross compiler\n"
Nico Huber152e78e2016-09-20 15:38:40 +0200447 printf " [-n|--nocolor] don't print color codes in output\n"
448 printf " [-u|--urls] print the urls for all packages\n"
Patrick Georgi73166c72010-04-14 20:42:42 +0000449 printf " [-j|--jobs <num>] run <num> jobs in parallel in make\n"
Martin Roth588c79d2016-03-20 12:03:20 -0600450 printf " [-s]--supported <tool> print supported version of a tool\n"
Stefan Reinauer074d9132009-09-26 16:43:17 +0000451 printf " [-d|--directory <target dir>] target directory to install cross compiler to\n"
Martin Roth588c79d2016-03-20 12:03:20 -0600452 printf " (defaults to $TARGETDIR)\n\n"
Stefan Reinauer074d9132009-09-26 16:43:17 +0000453 printf " [-D|--destdir <dest dir>] destination directory to install cross compiler to\n"
Stefan Reinauer2c3cd122011-11-01 21:43:50 +0100454 printf " (for RPM builds, default unset)\n"
Stefan Reinauer85b07d62015-06-09 14:45:14 -0700455 printf " [-P|--package <package>] Build a specific package: GCC, CLANG, IASL, GDB\n"
456 printf " (defaults to $PACKAGE)\n"
457 printf "GCC specific options:\n"
Nico Huber234d2462016-01-26 16:10:17 +0100458 printf " [-b|--bootstrap] bootstrap the host compiler before building\n"
459 printf " the cross compiler\n"
Stefan Reinauer85b07d62015-06-09 14:45:14 -0700460 printf " [-p|--platform <platform>] target platform to build cross compiler for\n"
461 printf " (defaults to $TARGETARCH)\n"
Nico Huberbb313bf2015-09-08 12:30:27 +0200462 printf " [-l|--languages <languages>] comma separated list of target languages\n"
Nico Huber66c2c1a2016-09-20 13:09:29 +0200463 printf " (defaults to $DEFAULT_LANGUAGES)\n"
Stefan Reinauer85b07d62015-06-09 14:45:14 -0700464 printf "GDB specific options:\n"
465 printf " [-p|--platform <platform>] target platform to build cross compiler for\n"
466 printf " (defaults to $TARGETARCH)\n"
467 printf " [-S|--scripting] build scripting support for GDB\n\n"
Martin Rothd1da74f2015-06-21 12:06:28 -0600468 printf "Platforms for GCC & GDB:\n"
Martin Roth3e0f74d2016-03-08 12:07:04 -0700469 printf " x86_64 i386-elf i386-mingw32 mipsel-elf riscv-elf arm aarch64\n"
Jonathan Neuschäferf14f6402016-03-11 20:22:23 +0100470 printf " powerpc64le-linux-gnu nds32le-elf\n\n"
Stefan Reinauer074d9132009-09-26 16:43:17 +0000471}
472
Martin Rothedf965a2015-11-25 16:58:33 -0700473printversion() {
474 printf "${blue}Welcome to the ${red}coreboot${blue} cross toolchain builder v$CROSSGCC_VERSION ($CROSSGCC_DATE)${NC}\n\n"
475}
476
Stefan Reinauer074d9132009-09-26 16:43:17 +0000477myversion()
478{
Martin Rothedf965a2015-11-25 16:58:33 -0700479 printversion
Stefan Reinauer074d9132009-09-26 16:43:17 +0000480
481 cat << EOF
Stefan Reinauer5f1ad892010-05-17 11:02:25 +0000482Copyright (C) 2008-2010 by coresystems GmbH
Marc Jones2aac3f62011-08-08 16:07:50 -0600483Copyright (C) 2011 by Sage Electronic Engineering
Stefan Reinauer074d9132009-09-26 16:43:17 +0000484
485This program is free software; you can redistribute it and/or modify
486it under the terms of the GNU General Public License as published by
487the Free Software Foundation; version 2 of the License.
488
489This program is distributed in the hope that it will be useful,
490but WITHOUT ANY WARRANTY; without even the implied warranty of
491MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
492GNU General Public License for more details.
493
494EOF
495}
496
Nico Huber5f72f962016-01-31 23:05:19 +0100497have_hostcflags_from_gmp() {
498 grep -q __GMP_CFLAGS $DESTDIR$TARGETDIR/include/gmp.h >/dev/null 2>&1
499}
500
501set_hostcflags_from_gmp() {
502 # Now set CFLAGS to match GMP CFLAGS but strip out -pedantic
503 # as GCC 4.6.x fails if it's there.
Idwer Volleringba349ab2016-07-24 02:10:19 +0200504 export HOSTCFLAGS="$(grep __GMP_CFLAGS $DESTDIR$TARGETDIR/include/gmp.h |cut -d\" -f2 |\
505 sed s,-pedantic,,)"
Nico Huber5f72f962016-01-31 23:05:19 +0100506}
507
Stefan Reinauere7757bd2015-06-05 13:59:44 -0700508build_GMP() {
Paul Kocialkowski7899db22016-06-17 21:41:00 -0700509 CC="$CC" ../${GMP_DIR}/configure --disable-shared --enable-fat \
Nico Huber5f72f962016-01-31 23:05:19 +0100510 --prefix=$TARGETDIR $OPTIONS \
Stefan Reinauere7757bd2015-06-05 13:59:44 -0700511 || touch .failed
512 $MAKE $JOBS || touch .failed
513 $MAKE install DESTDIR=$DESTDIR || touch .failed
514
515 normalize_dirs
Stefan Reinauer1c70e052015-06-09 11:47:28 -0700516
Nico Huber5f72f962016-01-31 23:05:19 +0100517 set_hostcflags_from_gmp
Stefan Reinauere7757bd2015-06-05 13:59:44 -0700518}
519
520build_MPFR() {
521 test $UNAME = "Darwin" && CFLAGS="$CFLAGS -force_cpusubtype_ALL"
522 CC="$CC" ../${MPFR_DIR}/configure --disable-shared --prefix=$TARGETDIR \
523 --infodir=$TARGETDIR/info \
524 --with-gmp=$DESTDIR$TARGETDIR CFLAGS="$HOSTCFLAGS" || \
525 touch .failed
526 $MAKE $JOBS || touch .failed
527 $MAKE install DESTDIR=$DESTDIR || touch .failed
528
529 normalize_dirs
530
531 # work around build problem of libgmp.la
532 if [ "$DESTDIR" != "" ]; then
533 perl -pi -e "s,$DESTDIR,," $DESTDIR$TARGETDIR/libgmp.la
534 fi
535}
536
537build_MPC() {
538 CC="$CC" ../${MPC_DIR}/configure --disable-shared --prefix=$TARGETDIR \
539 --infodir=$TARGETDIR/info --with-mpfr=$DESTDIR$TARGETDIR \
540 --with-gmp=$DESTDIR$TARGETDIR CFLAGS="$HOSTCFLAGS" || \
541 touch .failed
542 $MAKE $JOBS || touch .failed
543 $MAKE install DESTDIR=$DESTDIR || touch .failed
544
545 normalize_dirs
546}
547
548build_LIBELF() {
549 CC="$CC" CFLAGS="$HOSTCFLAGS" libelf_cv_elf_h_works=no \
550 ../${LIBELF_DIR}/configure --disable-shared --prefix=$TARGETDIR \
551 --infodir=$TARGETDIR/info CFLAGS="$HOSTCFLAGS" || touch .failed
552 $MAKE $JOBS || touch .failed
553 $MAKE install prefix=$DESTDIR$TARGETDIR || touch .failed
554
555 normalize_dirs
556}
557
558build_BINUTILS() {
Stefan Reinauer682a90c2015-06-09 14:59:58 -0700559 if [ $TARGETARCH == "x86_64-elf" ]; then
560 ADDITIONALTARGET=",i386-elf"
561 fi
Stefan Reinauere7757bd2015-06-05 13:59:44 -0700562 CC="$CC" ../binutils-${BINUTILS_VERSION}/configure --prefix=$TARGETDIR \
Stefan Reinauer682a90c2015-06-09 14:59:58 -0700563 --target=${TARGETARCH} --enable-targets=${TARGETARCH}${ADDITIONALTARGET} \
564 --disable-werror --disable-nls --enable-lto --enable-gold \
Stefan Reinauer2fe2d3d2016-04-05 02:14:48 -0700565 --enable-interwork --enable-multilib \
Stefan Reinauer682a90c2015-06-09 14:59:58 -0700566 --enable-plugins --enable-multilibs CFLAGS="$HOSTCFLAGS" || touch .failed
Stefan Reinauere7757bd2015-06-05 13:59:44 -0700567 $MAKE $JOBS || touch .failed
568 $MAKE install DESTDIR=$DESTDIR || touch .failed
569}
570
Nico Huber234d2462016-01-26 16:10:17 +0100571bootstrap_GCC() {
572 CC="$CC" \
573 CFLAGS="$HOSTCFLAGS" \
574 CFLAGS_FOR_BUILD="$HOSTCFLAGS" \
575 CFLAGS_FOR_TARGET="$HOSTCFLAGS -fPIC" \
576 CXXFLAGS="$HOSTCFLAGS" \
577 CXXFLAGS_FOR_BUILD="$HOSTCFLAGS" \
578 CXXFLAGS_FOR_TARGET="$HOSTCFLAGS -fPIC" \
579 ../gcc-${GCC_VERSION}/configure \
580 --prefix=$TARGETDIR --libexecdir=$TARGETDIR/lib \
581 --enable-bootstrap \
582 --disable-werror --disable-nls \
583 --disable-shared --disable-multilib \
584 --disable-libssp --disable-libquadmath --disable-libcc1 \
585 ${GCC_OPTIONS} --enable-languages="${LANGUAGES}" \
586 --with-gmp=$DESTDIR$TARGETDIR --with-mpfr=$DESTDIR$TARGETDIR \
587 --with-mpc=$DESTDIR$TARGETDIR --with-libelf=$DESTDIR$TARGETDIR \
588 --with-pkgversion="coreboot bootstrap v$CROSSGCC_VERSION $CROSSGCC_DATE" \
589 && \
590 $MAKE $JOBS BOOT_CFLAGS="$HOSTCFLAGS" BUILD_CONFIG="" bootstrap && \
591 $MAKE install-gcc \
592 install-target-libgcc \
593 maybe-install-target-libada \
594 maybe-install-target-libstdc++-v3 \
595 DESTDIR=$DESTDIR && \
596 ln -s gcc $DESTDIR$TARGETDIR/bin/cc || touch .failed
597}
Stefan Reinauere7757bd2015-06-05 13:59:44 -0700598
Nico Huber234d2462016-01-26 16:10:17 +0100599build_cross_GCC() {
Stefan Reinauer45f77b82016-04-03 20:52:01 -0700600 # Work around crazy code generator in GCC that confuses CLANG.
Aaron Durbinb2229dc2016-04-07 16:58:10 -0500601 $CC --version | grep clang >/dev/null 2>&1 && \
Stefan Reinauer45f77b82016-04-03 20:52:01 -0700602 HOSTCFLAGS="$HOSTCFLAGS -fbracket-depth=1024"
603
Stefan Reinauerd0f83722015-06-09 11:52:28 -0700604 # GCC does not honor HOSTCFLAGS at all. CFLAGS are used for
605 # both target and host object files.
Stefan Reinauere7757bd2015-06-05 13:59:44 -0700606 # There's a work-around called CFLAGS_FOR_BUILD and CFLAGS_FOR_TARGET
607 # but it does not seem to work properly. At least the host library
608 # libiberty is not compiled with CFLAGS_FOR_BUILD.
Stefan Reinauer45f77b82016-04-03 20:52:01 -0700609 # Also set the CXX version of the flags because GCC is now compiled
610 # using C++.
Patrick Georgi0a97d7e2016-01-25 09:51:22 +0100611 CC="$CC" CFLAGS_FOR_TARGET="-O2 -Dinhibit_libc" CFLAGS="$HOSTCFLAGS" \
Stefan Reinauer45f77b82016-04-03 20:52:01 -0700612 CFLAGS_FOR_BUILD="$HOSTCFLAGS" CXXFLAGS="$HOSTCFLAGS" \
613 CXXFLAGS_FOR_BUILD="$HOSTCFLAGS" ../gcc-${GCC_VERSION}/configure \
Stefan Reinauere7757bd2015-06-05 13:59:44 -0700614 --prefix=$TARGETDIR --libexecdir=$TARGETDIR/lib \
615 --target=${TARGETARCH} --disable-werror --disable-shared \
Stefan Reinauer2f97ebc2015-06-09 12:24:54 -0700616 --enable-lto --enable-plugins --enable-gold --enable-ld=default \
Stefan Reinauere7757bd2015-06-05 13:59:44 -0700617 --disable-libssp --disable-bootstrap --disable-nls \
618 --disable-libquadmath --without-headers \
Patrick Georgi0a97d7e2016-01-25 09:51:22 +0100619 --disable-threads \
Patrick Georgi1fc02d12016-03-23 21:44:43 +0100620 --enable-interwork --enable-multilib --enable-targets=all \
Patrick Georgi0a97d7e2016-01-25 09:51:22 +0100621 --disable-libatomic --disable-libcc1 --disable-decimal-float \
Nico Huberbb313bf2015-09-08 12:30:27 +0200622 ${GCC_OPTIONS} --enable-languages="${LANGUAGES}" \
Ronald G. Minnich7ee16b72016-02-12 21:54:59 +0000623 --with-system-zlib \
Stefan Reinauere7757bd2015-06-05 13:59:44 -0700624 --with-gmp=$DESTDIR$TARGETDIR --with-mpfr=$DESTDIR$TARGETDIR \
625 --with-mpc=$DESTDIR$TARGETDIR --with-libelf=$DESTDIR$TARGETDIR \
626 --with-pkgversion="coreboot toolchain v$CROSSGCC_VERSION $CROSSGCC_DATE" \
627 || touch .failed
628 $MAKE $JOBS CFLAGS_FOR_BUILD="$HOSTCFLAGS" all-gcc || touch .failed
629 $MAKE install-gcc DESTDIR=$DESTDIR || touch .failed
630
Stefan Reinauerd7649122015-06-09 11:44:25 -0700631 if [ "$(echo $TARGETARCH | grep -c -- -mingw32)" -eq 0 ]; then
Stefan Reinauere7757bd2015-06-05 13:59:44 -0700632 $MAKE $JOBS CFLAGS_FOR_BUILD="$HOSTCFLAGS" all-target-libgcc || touch .failed
633 $MAKE install-target-libgcc DESTDIR=$DESTDIR || touch .failed
634 fi
635}
636
Nico Huber234d2462016-01-26 16:10:17 +0100637build_GCC() {
638 if [ "$1" = host ]; then
639 bootstrap_GCC
640 else
641 build_cross_GCC
642 fi
643}
644
Stefan Reinauere7757bd2015-06-05 13:59:44 -0700645build_EXPAT() {
646 CC="$CC" CFLAGS="$HOSTCFLAGS" ../${EXPAT_DIR}/configure --disable-shared \
Stefan Reinauera344b682016-04-21 19:29:51 -0700647 --prefix=$TARGETDIR || touch .failed
Stefan Reinauere7757bd2015-06-05 13:59:44 -0700648 $MAKE || touch .failed
649 $MAKE install DESTDIR=$DESTDIR || touch .failed
650
651 normalize_dirs
652}
653
654build_PYTHON() {
655 CC="$CC" CFLAGS="$HOSTCFLAGS" ../${PYTHON_DIR}/configure --prefix=$TARGETDIR \
Stefan Reinauera344b682016-04-21 19:29:51 -0700656 || touch .failed
Stefan Reinauere7757bd2015-06-05 13:59:44 -0700657 $MAKE $JOBS || touch .failed
658 $MAKE install DESTDIR=$DESTDIR || touch .failed
659
660 normalize_dirs
661}
662
663build_GDB() {
664 export PYTHONHOME=$DESTDIR$TARGETDIR
665 if [ $(uname) != "FreeBSD" -a $(uname) != "NetBSD" ]; then
666 LIBDL="-ldl"
667 fi
668 LDFLAGS="-Wl,-rpath,\$\$ORIGIN/../lib/ -L$DESTDIR$TARGETDIR/lib \
669 -lpthread $LIBDL -lutil" \
670 CC="$CC" CFLAGS="$HOSTCFLAGS -I$DESTDIR$TARGETDIR/include" \
Stefan Reinauer7b40e422015-06-09 11:56:32 -0700671 ../${GDB_DIR}/configure --prefix=$TARGETDIR \
Stefan Reinauere7757bd2015-06-05 13:59:44 -0700672 --target=${TARGETARCH} --disable-werror --disable-nls
673 $MAKE $JOBS || touch .failed
674 $MAKE install DESTDIR=$DESTDIR || touch .failed
675}
676
677build_IASL() {
678 RDIR=$PWD
679 cd ../$IASL_DIR/generate/unix
680 CFLAGS="$HOSTCFLAGS"
681 HOST="_LINUX"
682 test $UNAME = "Darwin" && HOST="_APPLE"
683 test $UNAME = "FreeBSD" && HOST="_FreeBSD"
684 test $UNAME = "Cygwin" && HOST="_CYGWIN"
Martin Roth6f656132015-12-08 11:14:10 -0700685 HOST="$HOST" OPT_CFLAGS="-O -D_FORTIFY_SOURCE=2 -D COREBOOT_TOOLCHAIN_VERSION='\"coreboot toolchain v$CROSSGCC_VERSION $CROSSGCC_DATE\"' " CFLAGS="$CFLAGS" $MAKE CC="$CC" iasl || touch $RDIR/.failed
Stefan Reinauere7757bd2015-06-05 13:59:44 -0700686 rm -f $DESTDIR$TARGETDIR/bin/iasl || touch $RDIR/.failed
687 cp bin/iasl $DESTDIR$TARGETDIR/bin || touch $RDIR/.failed
688}
689
690build_LLVM() {
691 cd ..
692 ln -sf $PWD/$CFE_DIR $LLVM_DIR/tools/clang
693 ln -sf $PWD/$CTE_DIR $LLVM_DIR/tools/clang/tools/extra
694 ln -sf $PWD/$CRT_DIR $LLVM_DIR/projects/compiler-rt
695 cd -
696
697 $CMAKE -G "Unix Makefiles" -DCMAKE_INSTALL_PREFIX=$DESTDIR$TARGETDIR \
Martin Rothfb5647a2015-12-18 09:26:45 -0700698 -DCLANG_VENDOR="coreboot toolchain v$CROSSGCC_VERSION $CROSSGCC_DATE - " \
Stefan Reinauere7757bd2015-06-05 13:59:44 -0700699 -DCMAKE_BUILD_TYPE=Release ../$LLVM_DIR || touch .failed
700 $MAKE $JOBS || touch .failed
701 $MAKE install || touch .failed
702
703 cp -a ../$CFE_DIR/tools/scan-build/* $DESTDIR$TARGETDIR/bin
704 cp -a ../$CFE_DIR/tools/scan-view/* $DESTDIR$TARGETDIR/bin
Stefan Reinauere9e6e3d2015-07-07 00:20:42 +0200705
706 # create symlinks to work around broken --print-librt-file-name
707 # when used with -target.
708 cd $DESTDIR$TARGETDIR/lib/clang/${CLANG_VERSION}/lib
709 for i in */libclang_rt.builtins*.a; do
710 ln -s $i .
711 done
Stefan Reinauere7757bd2015-06-05 13:59:44 -0700712}
713
Stefan Reinauera851bbb2016-01-29 18:03:26 -0800714build_MAKE() {
715 CC="$CC" CFLAGS="$HOSTCFLAGS" ../${MAKE_DIR}/configure --prefix=$TARGETDIR \
716 --disable-nls || touch .failed
717 $MAKE $JOBS || touch .failed
718 $MAKE install DESTDIR=$DESTDIR || touch .failed
719
720 normalize_dirs
721}
722
Martin Rothedf965a2015-11-25 16:58:33 -0700723print_stable() {
724 case "$PRINTSTABLE" in
725 AUTOCONF|autoconf) printf "%s\n" "$GCC_AUTOCONF_VERSION";;
726 BINUTILS|binutils) printf "%s\n" "$BINUTILS_VERSION";;
727 CLANG|clang) printf "%s\n" "$CLANG_VERSION";;
728 EXPAT|expat) printf "%s\n" "$EXPAT_VERSION";;
729 GCC|gcc) printf "%s\n" "$GCC_VERSION";;
730 GDB|gdb) printf "%s\n" "$GDB_VERSION";;
731 GMP|gmp) printf "%s\n" "$GMP_VERSION";;
732 IASL|iasl) printf "%s\n" "$IASL_VERSION";;
733 LIBELF|libelf) printf "%s\n" "$LIBELF_VERSION";;
734 MPC|mpc) printf "%s\n" "$MPC_VERSION";;
735 MPFR|mpfr) printf "%s\n" "$MPFR_VERSION";;
736 PYTHON|python) printf "%s\n" "$PYTHON_VERSION";;
Stefan Reinauera851bbb2016-01-29 18:03:26 -0800737 MAKE|make) printf "%s\n" "$MAKE_VERSION";;
Martin Rothedf965a2015-11-25 16:58:33 -0700738 *) printf "Unknown tool %s\n" "$PRINTSTABLE";;
739 esac
740}
Stefan Reinauer074d9132009-09-26 16:43:17 +0000741
Zheng Baobb003c82016-08-05 13:41:51 +0800742trap quit 1 2 3 15
743
Patrick Georgi6bba29f2010-01-29 17:40:52 +0000744# Look if we have getopt. If not, build it.
745export PATH=$PATH:.
746getopt - > /dev/null 2>/dev/null || gcc -o getopt getopt.c
747
Stefan Reinauer074d9132009-09-26 16:43:17 +0000748# parse parameters.. try to find out whether we're running GNU getopt
Stefan Reinauerd7649122015-06-09 11:44:25 -0700749getoptbrand="$(getopt -V | sed -e '1!d' -e 's,^\(......\).*,\1,')"
Peter Stuge09377b72011-08-21 06:24:55 +0200750if [ "${getoptbrand}" = "getopt" ]; then
Stefan Reinauer074d9132009-09-26 16:43:17 +0000751 # Detected GNU getopt that supports long options.
Nico Hubercc414dd2016-09-20 13:59:38 +0200752 args=$(getopt -l version,help,clean,directory:,bootstrap,platform:,languages:,package:,jobs:,destdir:,savetemps,scripting,ccache,supported:,urls,nocolor -o Vhcd:bp:l:P:j:D:tSys:un -- "$@")
Nico Huber78df0bf2016-09-20 14:11:53 +0200753 getopt_ret=$?
Nico Hubercc414dd2016-09-20 13:59:38 +0200754 eval set -- "$args"
Stefan Reinauer074d9132009-09-26 16:43:17 +0000755else
756 # Detected non-GNU getopt
Nico Huber152e78e2016-09-20 15:38:40 +0200757 args=$(getopt Vhcd:bp:l:P:j:D:tSys:un $*)
Nico Huber78df0bf2016-09-20 14:11:53 +0200758 getopt_ret=$?
Stefan Reinauer074d9132009-09-26 16:43:17 +0000759 set -- $args
760fi
761
Nico Huber78df0bf2016-09-20 14:11:53 +0200762if [ $getopt_ret != 0 ]; then
Stefan Reinauer074d9132009-09-26 16:43:17 +0000763 myhelp
764 exit 1
765fi
766
767while true ; do
768 case "$1" in
769 -V|--version) shift; myversion; exit 0;;
770 -h|--help) shift; myhelp; exit 0;;
Patrick Georgi44af57a2013-12-19 22:06:22 +0100771 -c|--clean) shift; clean=1;;
Stefan Reinauer074d9132009-09-26 16:43:17 +0000772 -t|--savetemps) shift; SAVETEMPS=1;;
773 -d|--directory) shift; TARGETDIR="$1"; shift;;
Nico Huber234d2462016-01-26 16:10:17 +0100774 -b|--bootstrap) shift; BOOTSTRAP=1;;
Stefan Reinauer074d9132009-09-26 16:43:17 +0000775 -p|--platform) shift; TARGETARCH="$1"; shift;;
Nico Huberbb313bf2015-09-08 12:30:27 +0200776 -l|--languages) shift; LANGUAGES="$1"; shift;;
Stefan Reinauer074d9132009-09-26 16:43:17 +0000777 -D|--destdir) shift; DESTDIR="$1"; shift;;
Martin Roth2c6a8062016-11-14 11:58:39 -0700778 -j|--jobs) shift; THREADS="$1"; JOBS="-j $1"; shift;;
Stefan Reinauer85b07d62015-06-09 14:45:14 -0700779 -P|--package) shift; PACKAGE="$1"; shift;;
Stefan Reinauer2c3cd122011-11-01 21:43:50 +0100780 -S|--scripting) shift; SKIPPYTHON=0;;
Patrick Georgic1a75b12011-11-04 21:37:14 +0100781 -y|--ccache) shift; USECCACHE=1;;
Martin Rothedf965a2015-11-25 16:58:33 -0700782 -s|--supported) shift; PRINTSTABLE="$1"; shift;;
Nico Huber152e78e2016-09-20 15:38:40 +0200783 -u|--urls) shift; printf "%s\n" "$ALL_ARCHIVES"; exit 0;;
784 -n|--nocolor) shift; \
Martin Roth4a53db02016-03-01 15:21:07 -0700785 unset red RED green GREEN blue BLUE cyan CYAN NC;;
Patrick Georgid2e0dd52013-06-09 08:05:45 +0200786 --) shift; break;;
Patrick Georgid2e0dd52013-06-09 08:05:45 +0200787 *) break;;
Stefan Reinauer074d9132009-09-26 16:43:17 +0000788 esac
789done
790
Nico Huberbd74d562016-09-20 14:16:43 +0200791if [ $# -gt 0 ]; then
792 printf "Excessive arguments: $*\n"
793 myhelp
794 exit 1
795fi
796
Martin Rothedf965a2015-11-25 16:58:33 -0700797if [ -n "$PRINTSTABLE" ]; then
798 print_stable
799 exit 0
800fi
801
802#print toolchain builder version string as the header
803printversion
804
Martin Roth2c6a8062016-11-14 11:58:39 -0700805printf "Building toolchain using %d thread(s).\n\n" "$THREADS"
806
Ronald G. Minnichb460a662013-05-26 05:33:35 -0700807case "$TARGETARCH" in
Timothy Pearsona9f62352015-12-30 18:59:00 -0600808 x86_64-elf) ;;
809 x86_64*) TARGETARCH=x86_64-elf;;
810 i386-elf) ;;
811 i386-mingw32) ;;
812 mipsel-elf) ;;
Iru Caiae8e3a02016-04-02 10:50:59 +0800813 riscv-elf) TARGETARCH=riscv64-elf;;
Patrick Georgi0a97d7e2016-01-25 09:51:22 +0100814 powerpc64*-linux*) ;;
Timothy Pearsona9f62352015-12-30 18:59:00 -0600815 i386*) TARGETARCH=i386-elf;;
Stefan Reinauer27522ad2016-01-29 17:31:34 -0800816 arm*) TARGETARCH=arm-eabi;;
Timothy Pearsona9f62352015-12-30 18:59:00 -0600817 aarch64*) TARGETARCH=aarch64-elf;;
Martin Roth3e0f74d2016-03-08 12:07:04 -0700818 nds32le-elf) ;;
Timothy Pearsona9f62352015-12-30 18:59:00 -0600819 *) printf "${red}WARNING: Unsupported architecture $TARGETARCH.${NC}\n\n"; ;;
Ronald G. Minnichb460a662013-05-26 05:33:35 -0700820esac
821
Stefan Reinauer5dd26352015-06-09 14:52:22 -0700822# Figure out which packages to build
Stefan Reinauer699ac272015-06-05 12:43:28 -0700823
Stefan Reinauer85b07d62015-06-09 14:45:14 -0700824case "$PACKAGE" in
825 GCC|gcc)
826 echo "Target architecture is now $TARGETARCH"
827 NAME="${TARGETARCH} cross GCC"
Stefan Reinauerbd8b2e32015-06-17 11:55:02 -0700828 PACKAGES="GMP MPFR MPC LIBELF BINUTILS GCC"
Stefan Reinauer85b07d62015-06-09 14:45:14 -0700829 ;;
830 GDB|gdb)
831 NAME="${TARGETARCH} cross GDB"
Stefan Reinauer85b07d62015-06-09 14:45:14 -0700832 if [ $SKIPPYTHON -eq 0 ]; then
Ronald G. Minnichfb944f42016-02-27 04:06:42 +0000833 PACKAGES="EXPAT PYTHON GDB"
834 else
835 PACKAGES="EXPAT GDB"
Stefan Reinauer85b07d62015-06-09 14:45:14 -0700836 fi
837 ;;
838 CLANG|clang)
839 NAME=clang
840 PACKAGES="LLVM CFE CRT CTE"
David Hendrickscd5cdd32015-06-15 17:03:22 -0700841 CMAKE=$(searchtool cmake "cmake") || exit $?
Stefan Reinauer85b07d62015-06-09 14:45:14 -0700842 ;;
843 IASL|iasl)
844 NAME="IASL ACPI compiler"
845 PACKAGES=IASL
846 ;;
Stefan Reinauera851bbb2016-01-29 18:03:26 -0800847 MAKE|make)
848 NAME="GNU Make"
849 PACKAGES=MAKE
850 ;;
Stefan Reinauer85b07d62015-06-09 14:45:14 -0700851 *)
Stefan Reinauera851bbb2016-01-29 18:03:26 -0800852 printf "${red}ERROR: Unsupported package $PACKAGE. (Supported packages are GCC, GDB, CLANG, IASL, MAKE)${NC}\n\n";
Stefan Reinauer85b07d62015-06-09 14:45:14 -0700853 exit 1
854 ;;
855esac
Peter Stugeceacd772011-06-09 04:54:16 +0200856
Stefan Reinauer66e93352015-06-16 22:38:23 +0200857# Find all the required tools:
858
859TAR=$(searchtool tar) || exit $?
860PATCH=$(searchtool patch) || exit $?
861MAKE=$(searchtool make) || exit $?
862SHA1SUM=$(searchtool sha1sum)
zbao5cf758d2015-09-01 22:28:57 -0400863#SHA512SUM=$(searchtool sha512sum)
864#MD5SUM=$(searchtool md5sum)
Stefan Reinauer66e93352015-06-16 22:38:23 +0200865CHECKSUM=$SHA1SUM
Martin Roth95f7b222016-03-20 12:38:48 -0600866LBZIP2=$(searchtool lbzip2 "" nofail)
867PIGZ=$(searchtool pigz "" nofail)
Stefan Reinauer66e93352015-06-16 22:38:23 +0200868
869searchtool m4 > /dev/null
870searchtool bison > /dev/null
871searchtool flex flex > /dev/null
872searchtool g++ "Free Software Foundation" nofail > /dev/null || \
Marc Jones5ee69512015-06-17 15:38:17 -0600873searchtool clang "clang version" nofail > /dev/null || \
Martin Rothe3963172016-01-06 13:54:32 -0700874searchtool clang "LLVM" "" "g++" > /dev/null
Stefan Reinauer66e93352015-06-16 22:38:23 +0200875searchtool wget > /dev/null
876searchtool bzip2 "bzip2," > /dev/null
877
Martin Roth591790f2016-03-20 20:39:04 -0600878check_for_library "-lz" "zlib (zlib1g-dev or zlib-devel)"
879
Nico Huber156d87c2016-09-20 12:59:53 +0200880CC=cc
881check_cc
882
Martin Roth88463822016-01-07 11:03:36 -0700883if [ "$HALT_FOR_TOOLS" -ne 0 ]; then
884 exit 1
885fi
886
Stefan Reinauer5dd26352015-06-09 14:52:22 -0700887# This initial cleanup is useful when updating the toolchain script.
Stefan Reinauer5f1ad892010-05-17 11:02:25 +0000888
Stefan Reinauer5dd26352015-06-09 14:52:22 -0700889if [ "$clean" = "1" ]; then
890 cleanup
891fi
Stefan Reinauer074d9132009-09-26 16:43:17 +0000892
Stefan Reinauer5dd26352015-06-09 14:52:22 -0700893# Set up host compiler and flags needed for various OSes
Stefan Reinauer074d9132009-09-26 16:43:17 +0000894
Patrick Georgif2c15f52015-06-11 21:07:31 +0200895if is_package_enabled "GCC"; then
Stefan Reinauer0d2119d2013-07-10 14:27:56 -0700896if [ $UNAME = "Darwin" ]; then
Stefan Reinauer5f1ad892010-05-17 11:02:25 +0000897 #GCC_OPTIONS="$GCC_OPTIONS --enable-threads=posix"
898
899 # generally the OS X compiler can create x64 binaries.
900 # Per default it generated i386 binaries in 10.5 and x64
901 # binaries in 10.6 (even if the kernel is 32bit)
902 # For some weird reason, 10.5 autodetects an ABI=64 though
903 # so we're setting the ABI explicitly here.
Stefan Reinauerd7649122015-06-09 11:44:25 -0700904 if [ $(sysctl -n hw.optional.x86_64 2>/dev/null) -eq 1 ] 2>/dev/null; then
Stefan Reinauer5f1ad892010-05-17 11:02:25 +0000905 OPTIONS="ABI=64"
906 else
907 OPTIONS="ABI=32"
908 fi
Stefan Reinauer9491b4d2011-10-11 22:37:59 -0700909
Stefan Reinauer4266b922012-12-05 16:18:32 -0800910 # In Xcode 4.5.2 the default compiler is clang.
911 # However, this compiler fails to compile gcc 4.7.x. As a
912 # workaround it's possible to compile gcc with llvm-gcc.
Stefan Reinauer9491b4d2011-10-11 22:37:59 -0700913 if $CC -v 2>&1 | grep -q LLVM; then
Stefan Reinauer4266b922012-12-05 16:18:32 -0800914 CC=llvm-gcc
Stefan Reinauer9491b4d2011-10-11 22:37:59 -0700915 fi
zbao11f1d312015-08-05 23:15:54 -0400916elif [ $UNAME = "Linux" -o $UNAME = "Cygwin" ]; then
Patrick Georgiddb8f802015-07-04 17:45:54 +0200917 # gmp is overeager with detecting 64bit CPUs even if they run
918 # a 32bit kernel and userland.
919 if [ "$(uname -m 2>/dev/null)" = "i686" ]; then
920 OPTIONS="ABI=32"
921 fi
Nico Huberde45c592016-01-20 23:22:33 +0100922elif [ $UNAME = "NetBSD" ]; then
923 # same for NetBSD but this one reports an i386
924 if [ "$(uname -m 2>/dev/null)" = "i386" ]; then
925 OPTIONS="ABI=32"
926 fi
Stefan Reinauer5f1ad892010-05-17 11:02:25 +0000927fi
Nico Huber66c2c1a2016-09-20 13:09:29 +0200928if [ -z "${LANGUAGES}" ]; then
929 if hostcc_has_gnat1 && \
930 [ "$(hostcc_version)" = "$(buildcc_version)" -o "${BOOTSTRAP}" = "1" ];
931 then
932 printf "\nFound compatible Ada compiler, enabling Ada support by default.\n\n"
933 LANGUAGES="ada,${DEFAULT_LANGUAGES}"
934 else
935 LANGUAGES="${DEFAULT_LANGUAGES}"
936 fi
937fi
Stefan Reinauer14ce2132015-06-05 13:01:13 -0700938fi # GCC
Stefan Reinauer5f1ad892010-05-17 11:02:25 +0000939
Nico Huber5f72f962016-01-31 23:05:19 +0100940export HOSTCFLAGS="-Os"
941if have_hostcflags_from_gmp; then
942 set_hostcflags_from_gmp
943fi
944
Patrick Georgic1a75b12011-11-04 21:37:14 +0100945if [ "$USECCACHE" = 1 ]; then
946 CC="ccache $CC"
947fi
948
Stefan Reinauer5dd26352015-06-09 14:52:22 -0700949# Prepare target directory for building GCC
950# (dependencies must be in the PATH)
Stefan Reinauer16bd7892012-12-07 23:57:01 +0100951mkdir -p $DESTDIR$TARGETDIR/bin
Stefan Reinauer88352d72016-04-06 15:57:03 -0700952mkdir -p $DESTDIR$TARGETDIR/share
Stefan Reinauer16bd7892012-12-07 23:57:01 +0100953export PATH=$DESTDIR$TARGETDIR/bin:$PATH
954
Stefan Reinauer5dd26352015-06-09 14:52:22 -0700955# Download, unpack, patch and build all packages
956
Martin Roth03625172016-02-17 14:44:14 -0700957printf "Downloading tarballs ... \n"
Stefan Reinauer5dd26352015-06-09 14:52:22 -0700958mkdir -p tarballs
959for P in $PACKAGES; do
960 download $P
961done
Martin Roth03625172016-02-17 14:44:14 -0700962printf "Downloaded tarballs ... ${green}ok${NC}\n"
Stefan Reinauer5dd26352015-06-09 14:52:22 -0700963
964printf "Unpacking and patching ... \n"
965for P in $PACKAGES; do
966 unpack_and_patch $P || exit 1
967done
968printf "Unpacked and patched ... ${green}ok${NC}\n"
969
970printf "Building packages ... \n"
Stefan Reinauer1c70e052015-06-09 11:47:28 -0700971for package in $PACKAGES; do
972 build $package
973done
Stefan Reinauer5dd26352015-06-09 14:52:22 -0700974printf "Packages built ... ${green}ok${NC}\n"
Stefan Reinauer14ce2132015-06-05 13:01:13 -0700975
Stefan Reinauer699ac272015-06-05 12:43:28 -0700976# Adding git information of current tree to target directory
977# for reproducibility
Stefan Reinauerd7649122015-06-09 11:44:25 -0700978PROGNAME=$(basename "$0")
Stefan Reinauer88352d72016-04-06 15:57:03 -0700979rm -f "$DESTDIR$TARGETDIR/share/$PROGNAME-*"
980cp "$PROGNAME" "$DESTDIR$TARGETDIR/share/$PROGNAME-$CROSSGCC_VERSION-$CROSGCC_COMMIT"
Zheng Bao30b895f2013-02-06 18:04:40 +0800981
Stefan Reinauer88e83e52016-04-06 15:39:48 -0700982cleanup
Stefan Reinauer074d9132009-09-26 16:43:17 +0000983
Stefan Reinauer699ac272015-06-05 12:43:28 -0700984printf "\n${green}You can now run your $NAME toolchain from $TARGETDIR.${NC}\n"